#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct endereco {
	char rua[60];
	int num;
	char compl[60];
	char bairro[60];
	int cep;
	char estado[2];
	char pais[2];
};
typedef struct endereco Endereco;

struct telefone {
	int ddd;
	int numero;
};
typedef struct telefone Telefone;

struct data {
	int dia;
	int mes;
	int ano;
};
typedef struct data Data;

struct pessoa {
	char nome[60];
	char email[60];
	Endereco endereco;
	Telefone tel;
	Data aniversario;
	char obs[120];
};
typedef struct pessoa Pessoa;

void bubbleSortNome (Pessoa *agenda, int qtd) {
	Pessoa aux;
	for (int i = 0; i < qtd; ++i) {
		for (int j = i + 1; j < qtd; ++j)	{
			if (strcmp (agenda[j].nome, agenda[i].nome) < 0) {
				aux = agenda[i];
				agenda[i] = agenda[j];
				agenda[j] = aux;
			}
		}
	}
}

void preenche (Pessoa *pessoa) {
	printf("Nome:\n");
	fgets ((*pessoa).nome, 60, stdin); //Porque disso eu nao sei!
	fgets ((*pessoa).nome, 60, stdin);
	printf("Email:\n");
	fgets ((*pessoa).email, 60, stdin);
	printf("Endereco (rua, numero, complemento, bairro, cep, UF, pais):\n");
	fgets (((*pessoa).endereco).rua, 60, stdin);
	scanf("%d", &((*pessoa).endereco).num);
	fgets (((*pessoa).endereco).compl, 60, stdin);
	fgets (((*pessoa).endereco).bairro, 60, stdin);
	scanf(" %d", &((*pessoa).endereco).cep);
	scanf(" %s", ((*pessoa).endereco).estado);
	scanf(" %s", ((*pessoa).endereco).pais);
	printf("Telefone (ddd, numero):\n");
	scanf(" %d", &((*pessoa).tel).ddd);
	scanf(" %d", &((*pessoa).tel).numero);
	printf("Data de nascimento:\n");
	scanf(" %d", &((*pessoa).aniversario).dia);
	scanf(" %d", &((*pessoa).aniversario).mes);
	scanf(" %d", &((*pessoa).aniversario).ano);
	printf("Observacoes:\n");
	fgets ((*pessoa).obs, 120, stdin);
	printf("\n");
}

void mostra (Pessoa pessoa) {
	printf("\n--------------------------------\n");
	printf("%s\n", pessoa.nome);
	printf("%s\n", pessoa.email);
	printf("%s, ", (pessoa.endereco).rua);
	printf("%d, ", (pessoa.endereco).num);
	printf("%s, ", (pessoa.endereco).compl);
	printf("%s, ", (pessoa.endereco).bairro);
	printf("%d, ", (pessoa.endereco).cep);
	printf("%s, ", (pessoa.endereco).estado);
	printf("%s\n", (pessoa.endereco).pais);
	printf("(%d) ", (pessoa.tel).ddd);
	printf("%d\n", (pessoa.tel).numero);
	printf("%d - ", (pessoa.aniversario).dia);
	printf("%d - ", (pessoa.aniversario).mes);
	printf("%d\n", (pessoa.aniversario).ano);
	printf("%s\n", pessoa.obs);
	printf("\n--------------------------------\n");
}

void mostraPouco (Pessoa pessoa) {
	printf("\n--------------------------------\n");
	printf("%s\n", pessoa.nome);
	printf("(%d) ", (pessoa.tel).ddd);
	printf("%d\n", (pessoa.tel).numero);
	printf("%s\n", pessoa.email);
	printf("\n--------------------------------\n");
}

void buscaNome (Pessoa *agenda, char *busca, int qtd) {
	for (int i = 0; i < qtd; ++i) {
		if (strcmp(agenda[i].nome, busca) == 0) mostra (agenda[i]);
	}
}

void buscaMes (Pessoa *agenda, int busca, int qtd) {
	for (int i = 0; i < qtd; ++i) {
		if ((agenda[i].aniversario).mes == busca) mostra (agenda[i]);
	}
}

void buscaDiaMes (Pessoa *agenda, int buscaDia, int buscaMes, int qtd) {
	for (int i = 0; i < qtd; ++i) {
		if (((agenda[i].aniversario).dia == buscaDia) && ((agenda[i].aniversario).mes == buscaMes)) mostra (agenda[i]);
	}
}

void insere (Pessoa *agenda, int *qtd) {
	(*qtd) = 0;
	int sair = 1;
	while (sair != 0) {
		if ((*qtd) > 98) return;
		preenche (&agenda[(*qtd)]);
		bubbleSortNome (agenda, (*qtd));
		(*qtd) ++;

		printf("0 - para sair\n1 - para continuar\n");
		scanf (" %d", &sair);
	}
}

void retira (Pessoa *agenda, char *nome, int *qtd) {
	for (int i = 0; i < (*qtd); ++i) {
		if (strcmp(agenda[i].nome, nome) == 0) {
			for (int j = i; j < (*qtd) - 1; ++j) agenda[j] = agenda[j + 1];
			(*qtd) --;
		}
	}
}

int main () {
	Pessoa agenda[100];
	int qtd = 0, buscames, buscadia;
	char op, busca[60];

	while (1) {
		printf("Digite a opcao correspondente, ou S para sair:\n");
		scanf (" %c", &op);

		switch (op) {
			case 'c':
				scanf (" %[^\n]s", busca);
				buscaNome (agenda, busca, qtd);
			break;

			case 'd':
				scanf (" %d", &buscames);
				buscaMes (agenda, buscames, qtd);
			break;

			case 'e':
				scanf (" %d", &buscames);
				scanf (" %d", &buscadia);
				buscaDiaMes (agenda, buscadia, buscames, qtd);
			break;

			case 'f':
				insere (agenda, &qtd);
			break;

			case 'g':
				scanf (" %[^\n]s", busca);
				retira (agenda, busca, &qtd);
			break;

			case 'h':
				printf("p - imprimir alguns\n");
				printf("a - imprimir tudo\n");
				scanf (" %c", &op);

				if (op == 'a') {
					for (int i = 0; i < qtd; ++i) mostra (agenda[i]);
				}
				else if (op == 'p') {
					for (int i = 0; i < qtd; ++i) mostraPouco (agenda[i]);
				}
			break;

			case 'S':
				return 0;
		}
	}
}